=== source/blender/freestyle/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2006 Blender Authors
#
# SPDX-License-Identifier: GPL-2.0-or-later

set(SRC
  FRS_freestyle.h
  intern/application/AppCanvas.cpp
  intern/application/AppCanvas.h
  intern/application/AppConfig.cpp
  intern/application/AppConfig.h
  intern/application/AppView.cpp
  intern/application/AppView.h
  intern/application/Controller.cpp
  intern/application/Controller.h
  intern/blender_interface/BlenderFileLoader.cpp
  intern/blender_interface/BlenderFileLoader.h
  intern/blender_interface/BlenderStrokeRenderer.cpp
  intern/blender_interface/BlenderStrokeRenderer.h
  intern/blender_interface/BlenderStyleModule.h
  intern/blender_interface/FRS_freestyle.cpp
  intern/geometry/BBox.h
  intern/geometry/Bezier.cpp
  intern/geometry/Bezier.h
  intern/geometry/FastGrid.cpp
  intern/geometry/FastGrid.h
  intern/geometry/FitCurve.cpp
  intern/geometry/FitCurve.h
  intern/geometry/Geom.h
  intern/geometry/GeomCleaner.cpp
  intern/geometry/GeomCleaner.h
  intern/geometry/GeomUtils.cpp
  intern/geometry/GeomUtils.h
  intern/geometry/Grid.cpp
  intern/geometry/Grid.h
  intern/geometry/GridHelpers.cpp
  intern/geometry/GridHelpers.h
  intern/geometry/HashGrid.cpp
  intern/geometry/HashGrid.h
  intern/geometry/Noise.cpp
  intern/geometry/Noise.h
  intern/geometry/Polygon.h
  intern/geometry/SweepLine.h
  intern/geometry/VecMat.h
  intern/geometry/matrix_util.cpp
  intern/geometry/matrix_util.h
  intern/geometry/normal_cycle.cpp
  intern/geometry/normal_cycle.h
  intern/image/GaussianFilter.cpp
  intern/image/GaussianFilter.h
  intern/image/Image.h
  intern/image/ImagePyramid.cpp
  intern/image/ImagePyramid.h
  intern/python/BPy_BBox.cpp
  intern/python/BPy_BBox.h
  intern/python/BPy_BinaryPredicate0D.cpp
  intern/python/BPy_BinaryPredicate0D.h
  intern/python/BPy_BinaryPredicate1D.cpp
  intern/python/BPy_BinaryPredicate1D.h
  intern/python/BPy_ContextFunctions.cpp
  intern/python/BPy_ContextFunctions.h
  intern/python/BPy_Convert.cpp
  intern/python/BPy_Convert.h
  intern/python/BPy_Freestyle.cpp
  intern/python/BPy_Freestyle.h
  intern/python/BPy_FrsMaterial.cpp
  intern/python/BPy_FrsMaterial.h
  intern/python/BPy_FrsNoise.cpp
  intern/python/BPy_FrsNoise.h
  intern/python/BPy_Id.cpp
  intern/python/BPy_Id.h
  intern/python/BPy_IntegrationType.cpp
  intern/python/BPy_IntegrationType.h
  intern/python/BPy_Interface0D.cpp
  intern/python/BPy_Interface0D.h
  intern/python/BPy_Interface1D.cpp
  intern/python/BPy_Interface1D.h
  intern/python/BPy_Iterator.cpp
  intern/python/BPy_Iterator.h
  intern/python/BPy_MediumType.cpp
  intern/python/BPy_MediumType.h
  intern/python/BPy_Nature.cpp
  intern/python/BPy_Nature.h
  intern/python/BPy_Operators.cpp
  intern/python/BPy_Operators.h
  intern/python/BPy_SShape.cpp
  intern/python/BPy_SShape.h
  intern/python/BPy_StrokeAttribute.cpp
  intern/python/BPy_StrokeAttribute.h
  intern/python/BPy_StrokeShader.cpp
  intern/python/BPy_StrokeShader.h
  intern/python/BPy_UnaryFunction0D.cpp
  intern/python/BPy_UnaryFunction0D.h
  intern/python/BPy_UnaryFunction1D.cpp
  intern/python/BPy_UnaryFunction1D.h
  intern/python/BPy_UnaryPredicate0D.cpp
  intern/python/BPy_UnaryPredicate0D.h
  intern/python/BPy_UnaryPredicate1D.cpp
  intern/python/BPy_UnaryPredicate1D.h
  intern/python/BPy_ViewMap.cpp
  intern/python/BPy_ViewMap.h
  intern/python/BPy_ViewShape.cpp
  intern/python/BPy_ViewShape.h
  intern/python/BinaryPredicate1D/BPy_FalseBP1D.cpp
  intern/python/BinaryPredicate1D/BPy_FalseBP1D.h
  intern/python/BinaryPredicate1D/BPy_Length2DBP1D.cpp
  intern/python/BinaryPredicate1D/BPy_Length2DBP1D.h
  intern/python/BinaryPredicate1D/BPy_SameShapeIdBP1D.cpp
  intern/python/BinaryPredicate1D/BPy_SameShapeIdBP1D.h
  intern/python/BinaryPredicate1D/BPy_TrueBP1D.cpp
  intern/python/BinaryPredicate1D/BPy_TrueBP1D.h
  intern/python/BinaryPredicate1D/BPy_ViewMapGradientNormBP1D.cpp
  intern/python/BinaryPredicate1D/BPy_ViewMapGradientNormBP1D.h
  intern/python/Director.cpp
  intern/python/Director.h
  intern/python/Interface0D/BPy_CurvePoint.cpp
  intern/python/Interface0D/BPy_CurvePoint.h
  intern/python/Interface0D/BPy_SVertex.cpp
  intern/python/Interface0D/BPy_SVertex.h
  intern/python/Interface0D/BPy_ViewVertex.cpp
  intern/python/Interface0D/BPy_ViewVertex.h
  intern/python/Interface0D/CurvePoint/BPy_StrokeVertex.cpp
  intern/python/Interface0D/CurvePoint/BPy_StrokeVertex.h
  intern/python/Interface0D/ViewVertex/BPy_NonTVertex.cpp
  intern/python/Interface0D/ViewVertex/BPy_NonTVertex.h
  intern/python/Interface0D/ViewVertex/BPy_TVertex.cpp
  intern/python/Interface0D/ViewVertex/BPy_TVertex.h
  intern/python/Interface1D/BPy_FEdge.cpp
  intern/python/Interface1D/BPy_FEdge.h
  intern/python/Interface1D/BPy_FrsCurve.cpp
  intern/python/Interface1D/BPy_FrsCurve.h
  intern/python/Interface1D/BPy_Stroke.cpp
  intern/python/Interface1D/BPy_Stroke.h
  intern/python/Interface1D/BPy_ViewEdge.cpp
  intern/python/Interface1D/BPy_ViewEdge.h
  intern/python/Interface1D/Curve/BPy_Chain.cpp
  intern/python/Interface1D/Curve/BPy_Chain.h
  intern/python/Interface1D/FEdge/BPy_FEdgeSharp.cpp
  intern/python/Interface1D/FEdge/BPy_FEdgeSharp.h
  intern/python/Interface1D/FEdge/BPy_FEdgeSmooth.cpp
  intern/python/Interface1D/FEdge/BPy_FEdgeSmooth.h
  intern/python/Iterator/BPy_AdjacencyIterator.cpp
  intern/python/Iterator/BPy_AdjacencyIterator.h
  intern/python/Iterator/BPy_ChainPredicateIterator.cpp
  intern/python/Iterator/BPy_ChainPredicateIterator.h
  intern/python/Iterator/BPy_ChainSilhouetteIterator.cpp
  intern/python/Iterator/BPy_ChainSilhouetteIterator.h
  intern/python/Iterator/BPy_ChainingIterator.cpp
  intern/python/Iterator/BPy_ChainingIterator.h
  intern/python/Iterator/BPy_CurvePointIterator.cpp
  intern/python/Iterator/BPy_CurvePointIterator.h
  intern/python/Iterator/BPy_Interface0DIterator.cpp
  intern/python/Iterator/BPy_Interface0DIterator.h
  intern/python/Iterator/BPy_SVertexIterator.cpp
  intern/python/Iterator/BPy_SVertexIterator.h
  intern/python/Iterator/BPy_StrokeVertexIterator.cpp
  intern/python/Iterator/BPy_StrokeVertexIterator.h
  intern/python/Iterator/BPy_ViewEdgeIterator.cpp
  intern/python/Iterator/BPy_ViewEdgeIterator.h
  intern/python/Iterator/BPy_orientedViewEdgeIterator.cpp
  intern/python/Iterator/BPy_orientedViewEdgeIterator.h
  intern/python/StrokeShader/BPy_BackboneStretcherShader.cpp
  intern/python/StrokeShader/BPy_BackboneStretcherShader.h
  intern/python/StrokeShader/BPy_BezierCurveShader.cpp
  intern/python/StrokeShader/BPy_BezierCurveShader.h
  intern/python/StrokeShader/BPy_BlenderTextureShader.cpp
  intern/python/StrokeShader/BPy_BlenderTextureShader.h
  intern/python/StrokeShader/BPy_CalligraphicShader.cpp
  intern/python/StrokeShader/BPy_CalligraphicShader.h
  intern/python/StrokeShader/BPy_ColorNoiseShader.cpp
  intern/python/StrokeShader/BPy_ColorNoiseShader.h
  intern/python/StrokeShader/BPy_ConstantColorShader.cpp
  intern/python/StrokeShader/BPy_ConstantColorShader.h
  intern/python/StrokeShader/BPy_ConstantThicknessShader.cpp
  intern/python/StrokeShader/BPy_ConstantThicknessShader.h
  intern/python/StrokeShader/BPy_ConstrainedIncreasingThicknessShader.cpp
  intern/python/StrokeShader/BPy_ConstrainedIncreasingThicknessShader.h
  intern/python/StrokeShader/BPy_GuidingLinesShader.cpp
  intern/python/StrokeShader/BPy_GuidingLinesShader.h
  intern/python/StrokeShader/BPy_IncreasingColorShader.cpp
  intern/python/StrokeShader/BPy_IncreasingColorShader.h
  intern/python/StrokeShader/BPy_IncreasingThicknessShader.cpp
  intern/python/StrokeShader/BPy_IncreasingThicknessShader.h
  intern/python/StrokeShader/BPy_PolygonalizationShader.cpp
  intern/python/StrokeShader/BPy_PolygonalizationShader.h
  intern/python/StrokeShader/BPy_SamplingShader.cpp
  intern/python/StrokeShader/BPy_SamplingShader.h
  intern/python/StrokeShader/BPy_SmoothingShader.cpp
  intern/python/StrokeShader/BPy_SmoothingShader.h
  intern/python/StrokeShader/BPy_SpatialNoiseShader.cpp
  intern/python/StrokeShader/BPy_SpatialNoiseShader.h
  intern/python/StrokeShader/BPy_StrokeTextureStepShader.cpp
  intern/python/StrokeShader/BPy_StrokeTextureStepShader.h
  intern/python/StrokeShader/BPy_ThicknessNoiseShader.cpp
  intern/python/StrokeShader/BPy_ThicknessNoiseShader.h
  intern/python/StrokeShader/BPy_TipRemoverShader.cpp
  intern/python/StrokeShader/BPy_TipRemoverShader.h
  intern/python/UnaryFunction0D/BPy_UnaryFunction0DDouble.cpp
  intern/python/UnaryFunction0D/BPy_UnaryFunction0DDouble.h
  intern/python/UnaryFunction0D/BPy_UnaryFunction0DEdgeNature.cpp
  intern/python/UnaryFunction0D/BPy_UnaryFunction0DEdgeNature.h
  intern/python/UnaryFunction0D/BPy_UnaryFunction0DFloat.cpp
  intern/python/UnaryFunction0D/BPy_UnaryFunction0DFloat.h
  intern/python/UnaryFunction0D/BPy_UnaryFunction0DId.cpp
  intern/python/UnaryFunction0D/BPy_UnaryFunction0DId.h
  intern/python/UnaryFunction0D/BPy_UnaryFunction0DMaterial.cpp
  intern/python/UnaryFunction0D/BPy_UnaryFunction0DMaterial.h
  intern/python/UnaryFunction0D/BPy_UnaryFunction0DUnsigned.cpp
  intern/python/UnaryFunction0D/BPy_UnaryFunction0DUnsigned.h
  intern/python/UnaryFunction0D/BPy_UnaryFunction0DVec2f.cpp
  intern/python/UnaryFunction0D/BPy_UnaryFunction0DVec2f.h
  intern/python/UnaryFunction0D/BPy_UnaryFunction0DVec3f.cpp
  intern/python/UnaryFunction0D/BPy_UnaryFunction0DVec3f.h
  intern/python/UnaryFunction0D/BPy_UnaryFunction0DVectorViewShape.cpp
  intern/python/UnaryFunction0D/BPy_UnaryFunction0DVectorViewShape.h
  intern/python/UnaryFunction0D/BPy_UnaryFunction0DViewShape.cpp
  intern/python/UnaryFunction0D/BPy_UnaryFunction0DViewShape.h
  intern/python/UnaryFunction0D/UnaryFunction0D_Id/BPy_ShapeIdF0D.cpp
  intern/python/UnaryFunction0D/UnaryFunction0D_Id/BPy_ShapeIdF0D.h
  intern/python/UnaryFunction0D/UnaryFunction0D_Material/BPy_MaterialF0D.cpp
  intern/python/UnaryFunction0D/UnaryFunction0D_Material/BPy_MaterialF0D.h
  intern/python/UnaryFunction0D/UnaryFunction0D_Nature_EdgeNature/BPy_CurveNatureF0D.cpp
  intern/python/UnaryFunction0D/UnaryFunction0D_Nature_EdgeNature/BPy_CurveNatureF0D.h
  intern/python/UnaryFunction0D/UnaryFunction0D_Vec2f/BPy_Normal2DF0D.cpp
  intern/python/UnaryFunction0D/UnaryFunction0D_Vec2f/BPy_Normal2DF0D.h
  intern/python/UnaryFunction0D/UnaryFunction0D_Vec2f/BPy_VertexOrientation2DF0D.cpp
  intern/python/UnaryFunction0D/UnaryFunction0D_Vec2f/BPy_VertexOrientation2DF0D.h
  intern/python/UnaryFunction0D/UnaryFunction0D_Vec3f/BPy_VertexOrientation3DF0D.cpp
  intern/python/UnaryFunction0D/UnaryFunction0D_Vec3f/BPy_VertexOrientation3DF0D.h
  intern/python/UnaryFunction0D/UnaryFunction0D_ViewShape/BPy_GetOccludeeF0D.cpp
  intern/python/UnaryFunction0D/UnaryFunction0D_ViewShape/BPy_GetOccludeeF0D.h
  intern/python/UnaryFunction0D/UnaryFunction0D_ViewShape/BPy_GetShapeF0D.cpp
  intern/python/UnaryFunction0D/UnaryFunction0D_ViewShape/BPy_GetShapeF0D.h
  intern/python/UnaryFunction0D/UnaryFunction0D_double/BPy_Curvature2DAngleF0D.cpp
  intern/python/UnaryFunction0D/UnaryFunction0D_double/BPy_Curvature2DAngleF0D.h
  intern/python/UnaryFunction0D/UnaryFunction0D_double/BPy_DensityF0D.cpp
  intern/python/UnaryFunction0D/UnaryFunction0D_double/BPy_DensityF0D.h
  intern/python/UnaryFunction0D/UnaryFunction0D_double/BPy_GetProjectedXF0D.cpp
  intern/python/UnaryFunction0D/UnaryFunction0D_double/BPy_GetProjectedXF0D.h
  intern/python/UnaryFunction0D/UnaryFunction0D_double/BPy_GetProjectedYF0D.cpp
  intern/python/UnaryFunction0D/UnaryFunction0D_double/BPy_GetProjectedYF0D.h
  intern/python/UnaryFunction0D/UnaryFunction0D_double/BPy_GetProjectedZF0D.cpp
  intern/python/UnaryFunction0D/UnaryFunction0D_double/BPy_GetProjectedZF0D.h
  intern/python/UnaryFunction0D/UnaryFunction0D_double/BPy_GetXF0D.cpp
  intern/python/UnaryFunction0D/UnaryFunction0D_double/BPy_GetXF0D.h
  intern/python/UnaryFunction0D/UnaryFunction0D_double/BPy_GetYF0D.cpp
  intern/python/UnaryFunction0D/UnaryFunction0D_double/BPy_GetYF0D.h
  intern/python/UnaryFunction0D/UnaryFunction0D_double/BPy_GetZF0D.cpp
